import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load_module, reload_module, get_stdout
from functools import reduce

exercise = 'src.order_of_magnitude'

@points('1.order_of_magnitude')
class OrderOfMagnitudeTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', return_value = '0'):
            cls.module = load_module(exercise, 'en')

    def test_print_1(self):
        number = 9
        with patch('builtins.input', return_value = str(number)):
            reload_module(self.module)
            output = get_stdout().split("\n")
            if number < 1000:
                self.assertEqual(output[0].strip(), "Detta tal är mindre än 1000", "Ditt program skrevs inte ut\nDetta tal är mindre än 1000\nför nummer " + str(number))
            if number < 100:
                self.assertTrue(len(output)>1, "Ditt program skrevs inte ut\nDetta tal är mindre än 100\nför nummer " + str(number))
                self.assertEqual(output[1].strip(), "Detta tal är mindre än 100", "Ditt program skrevs inte ut\nDetta tal är mindre än 100\nför nummer " + str(number))
            if number < 10:
                self.assertTrue(len(output)>2, "Ditt program skrevs inte ut\nDetta tal är mindre än 10\nför nummer " + str(number))
                self.assertEqual(output[2].strip(), "Detta tal är mindre än 10", "Ditt program skrevs inte ut\nDetta tal är mindre än 10\nför nummer " + str(number))
            self.assertEqual(output[-1], "Tack!", "I slutet av programmets körning, skrevs ditt program inte ut 'Tack!'")

    def test_print_2(self):
        number = 97
        with patch('builtins.input', return_value = str(number)):
            reload_module(self.module)
            output = get_stdout().split("\n")
            if number < 1000:
                self.assertEqual(output[0], "Detta tal är mindre än 1000", "Ditt program skrevs inte ut Detta tal är mindre än 1000 för nummer " + str(number))
            if number < 100:
                self.assertTrue(len(output)>1, "Ditt program skrevs inte ut\nDetta tal är mindre än 100\nför nummer " + str(number))
                self.assertEqual(output[1], "Detta tal är mindre än 100", "Ditt program skrevs inte ut Detta tal är mindre än 100 för nummer " + str(number))
            if number < 10:
                self.assertTrue(len(output)>2, "Ditt program skrevs inte ut\nDetta tal är mindre än 10\nför nummer " + str(number))
                self.assertEqual(output[2], "Detta tal är mindre än 10", "Ditt program skrev inte ut Detta tal är mindre än 10 för nummer " + str(number))
            self.assertEqual(output[-1], "Tack!", "I slutet av programmets körning, skrevs ditt program inte ut 'Tack!'")

    def test_print_3(self):
        number = 451
        with patch('builtins.input', return_value = str(number)):
            reload_module(self.module)
            output = get_stdout().split("\n")
            if number < 1000:
                self.assertEqual(output[0], "Detta tal är mindre än 1000", "Ditt program skrevs inte ut Detta tal är mindre än 1000 för nummer " + str(number))
            if number < 100:
                self.assertTrue(len(output)>1, "Ditt program skrevs inte ut\nDetta tal är mindre än 100\nför nummer " + str(number))
                self.assertEqual(output[1], "Detta tal är mindre än 100", "Ditt program skrevs inte ut Detta tal är mindre än 100 för nummer " + str(number))
            if number < 10:
                self.assertTrue(len(output)>2, "Ditt program skrevs inte ut\nDetta tal är mindre än 10\nför nummer " + str(number))
                self.assertEqual(output[2], "Detta tal är mindre än 10", "Ditt program skrev inte ut Detta tal är mindre än 10 för nummer " + str(number))
            self.assertEqual(output[-1], "Tack!", "I slutet av programmets körning, skrevs ditt program inte ut 'Tack!'")

    def test_print_4(self):
        number = 111234
        with patch('builtins.input', return_value = str(number)):
            reload_module(self.module)
            output = get_stdout().split("\n")
            if number < 1000:
                self.assertEqual(output[0], "Detta tal är mindre än 1000", "Ditt program skrevs inte ut Detta tal är mindre än 1000 för nummer " + str(number))
            if number < 100:
                self.assertTrue(len(output)>1, "Ditt program skrevs inte ut\nDetta tal är mindre än 100\nför nummer " + str(number))
                self.assertEqual(output[1], "Detta tal är mindre än 100", "Ditt program skrevs inte ut Detta tal är mindre än 100 för nummer " + str(number))
            if number < 10:
                self.assertTrue(len(output)>2, "Ditt program skrevs inte ut\nDetta tal är mindre än 10\nför nummer " + str(number))
                self.assertEqual(output[2], "Detta tal är mindre än 10", "Ditt program skrev inte ut Detta tal är mindre än 10 för nummer " + str(number))
            self.assertEqual(output[-1], "Tack!", "I slutet av programmets körning, skrevs ditt program inte ut 'Tack!'")

if __name__ == '__main__':
    unittest.main()
